# Author renyupeng
# coding=utf-8
# @Time    : 2022/02/07 14:43 下午
# @Site    :
# @File    : send_bytedance_material_month.py
# @Software: PyCharm
# @contact: zhaohailiang@c-top.com.cn
# @Tel 1501435553
import datetime
from urllib import parse
import pandas as pd
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from sqlalchemy import create_engine


class send_bytedance_material_month:
    def __init__(self):
        self.OuterStr = "mysql+pymysql://%s:%s@%s:%d/%s" % (
            "hcst", parse.quote_plus("hcst@2021"), "192.168.0.184", 3390, "application")
        self.OuterConn = create_engine(self.OuterStr,
                                       pool_size=10,
                                       max_overflow=5,
                                       pool_timeout=10,
                                       pool_recycle=3600)
        self.stat_date = (datetime.date.today() + datetime.timedelta(-1)).strftime("%Y-%m-%d")

    def handler(self):
        sql = """select (CASE
WHEN a.clip_company_id = 'd57fecdcf7a94d009736d9c850731582' THEN
'北京汇创思拓数字科技有限公司'
WHEN a.clip_company_id = '6608ed13c0dd42de93c790dbdf124234' THEN
'广州汇创思拓数字科技有限公司'
WHEN a.clip_company_id = '4b10089775c040119e139087517aed88' THEN
'上海汇创思拓数字科技有限公司'
WHEN a.clip_company_id = '5e46b5dea3d740eeb8ff1a2895015a4b' THEN
'北京骄阳数字科技有限公司'
WHEN a.clip_company_id = '1648c7ceb4d449a9a13fbed7a8d9976c' THEN
'杭州妙构思数字科技有限公司'
WHEN a.clip_company_id = '3321d5893bcd430cab1238a99bc7db11' THEN
'北京次元像素'
else '-'	
END) as '公司',
       a.project_name AS '项目',
       concat('`',a.account_id,'`')   AS '账户',
       a.signature   AS '素材标识',
       b.media_time AS '上线时间',
       '-' 渠道,
       a.charge AS '消耗',
       a.user_name AS '运营',
       a.clip_name AS '剪辑',
       a.shot_name AS '拍摄',
       a.plan_name AS '编导',
       a.leader_name AS '负责人',
       a.video_name AS '素材名称',
       a.video_url  AS '链接' from 
(select clip_company_id,account_id,company_name,project_name,signature,channel_name,sum(cost)charge,clip_name,shot_name,plan_name,a.leader_name,video_name,video_url,b.realname user_name from  
application.app_bytedance_video_report_busi_m a
left join `jeecg-boot`.sys_user b
on a.user_id=b.id
where stat_mon=202201
group by signature) a
left join 
application.app_bytedance_material_info b
on a.signature=b.material_id; """.format(stat_date=self.stat_date)
        print(sql)
        path = """/data/excel/send_bytedance_material_month.xls""".format(stat_date=self.stat_date)
        print(path)
        pd.read_sql(sql, self.OuterConn).to_excel(path, index=False, engine='openpyxl')
        my_sender = 'renyupeng@c-top.com.cn'  # 发件人邮箱账号
        my_pass = 'fcyJKkHUyPo6Zztw'  # 发件人邮箱授权码 / 腾讯企业邮箱请使用登陆密码
        recipients = ['niuxiaoyu@c-top.com.cn']  # 收件人邮箱账号
        # content = "Please check the attachment. "
        msg = MIMEMultipart()
        # [发件人的邮箱昵称、发件人邮箱账号], 昵称随便
        msg['From'] = my_sender
        # [收件人邮箱昵称、收件人邮箱账号], 昵称随便
        msg['To'] = ",".join(recipients)
        # 邮件的主题，也就是邮件的标题
        msg['Subject'] = "头条-全量素材月报"

        att1 = MIMEText(
            open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename="send_bytedance_material_month.xls"'
        msg.attach(att1)
        server = smtplib.SMTP_SSL("smtp.exmail.qq.com", port=465)
        server.login(my_sender, my_pass)
        try:
            server.sendmail(my_sender, recipients, msg.as_string())
            print("发送成功")
        except Exception as e:
            print("发送失败",e)


if __name__ == '__main__':
    send_bytedance_material_month().handler()
